Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    ListView1: TListView;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  private
    procedure CenterItem(LV: TListView; Index: Integer);
  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.CenterItem(LV: TListView; Index: Integer);
var
  Idx: Integer;
begin
  LV.Items[Index].MakeVisible(False);
  Idx := LV.TopItem.Index + (LV.VisibleRowCount div 2);
  if Index <> Idx then
    Idx := Index + (Index - Idx);
  if (Idx < 0) then
    Idx := 0;
  if (Idx >= LV.Items.Count) then
    Idx := LV.Items.Count - 1;
  LV.Items[Idx].MakeVisible(False);
end;

Procedure TForm1.FormCreate(Sender: TObject);
Var
  item: TListItem;
  i: Integer;
Begin
  Randomize;
  For i := 1 To 100 Do Begin
    item := ListView1.Items.Add;
    item.Caption := inttostr(i);
    item.SubItems.Add('Random');
    item.SubItems.Add(inttostr(Random(10000)));
  End;
End;

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  ListView1.ClearSelection;
  ListView1.Items[80].Selected := true;
  ListView1.ItemFocused := ListView1.Items[80];
  ListView1.SetFocus;

  CenterItem(ListView1, 80);

  //ListView1.Items[80].Selected := true;
  //ListView1.SetFocus;
  //ListView1.ItemIndex := 80;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  ListView1.ClearSelection;
  ListView1.Items[10].Selected := true;
  ListView1.SetFocus;
  ListView1.ItemIndex := 10;
End;



End.

